
#include "nettest.h"

double Ring (int msglen, int TIMES)
{
    char* Buffer[4];
    int iLeft, iRight;

    double dBeginTime, dEndTime, Rate, dUsedTime, dTime, dLatency;

    MPI_Status MPIStatus;
	MPI_Request Requests[4];

	int pool_size,rank,i_am_the_master,remote_rank;
	MPI_Status Status;
	int i;

    MPI_Comm_size (comm,&pool_size);
    MPI_Comm_rank (comm,&rank);

	i_am_the_master = (rank == 0) ? 1 : 0;

    iLeft = (rank + pool_size - 1) % pool_size;
    iRight = (rank + 1) % pool_size;
	
    for(i = 0; i < 4; i ++)
    	if((Buffer[i] = (char *) malloc (msglen)) == NULL)
			finish("Can't allocate memory");

    if ( Buffer == NULL )
		finish("Can't allocate memory");    

    MPI_Barrier(comm);
    dBeginTime = Wtime();

	for(i = 0; i < TIMES; i ++)
	{
		MPI_Isend (Buffer[0], msglen, MPI_CHAR, iLeft,iTAG, MPI_COMM_WORLD, &Requests[0]);
		MPI_Irecv (Buffer[3], msglen, MPI_CHAR, iRight,iTAG, MPI_COMM_WORLD, &Requests[3]);
		MPI_Wait(&Requests[0],&Status);
		MPI_Wait(&Requests[3],&Status);				
		MPI_Isend (Buffer[2], msglen, MPI_CHAR, iRight,iTAG, MPI_COMM_WORLD, &Requests[2]);
		MPI_Irecv (Buffer[1], msglen, MPI_CHAR, iLeft,iTAG, MPI_COMM_WORLD, &Requests[1]);
		MPI_Wait(&Requests[2],&Status);
		MPI_Wait(&Requests[1],&Status);				
	} /* End of for */

	MPI_Barrier(comm);   
	dEndTime = Wtime();
	dUsedTime = dEndTime - dBeginTime;

		/* rate is megabytes per second */
	Rate = ((double) TIMES * 2.0 * msglen)/(dUsedTime);

	for(i = 0; i < 4; i ++)
		free(Buffer[i]);

	  return(Rate);

} /* End of Ring ( ) */



