
#include "nettest.h"

double Ring2 ( int msglen, int TIMES)
{
    char* Buffer[4];
	int i;
    int iLeft, iRight, iCount;
    double dBeginTime, dEndTime, Rate, dUsedTime, dTime, dLatency;
	int rank,pool_size,i_am_the_master;

    MPI_Request MPIRequest[4];
    MPI_Status MPIStatus[4];

    MPI_Comm_size (comm, &pool_size);
    MPI_Comm_rank (comm, &rank);

	i_am_the_master = (rank == 0) ? 1 : 0;

    iLeft = (rank + pool_size - 1) % pool_size;
    iRight = (rank + 1 ) % pool_size;

    for(i = 0; i < 4; i ++)
    	if((Buffer[i] = (char *) malloc (msglen)) == NULL)
			finish("Can't allocate memory");
	
    MPI_Barrier(comm);

    dBeginTime = Wtime();

	for ( iCount = 0; iCount < TIMES; iCount++ )
	{
		MPI_Isend(Buffer[0], msglen, MPI_CHAR, iLeft, iTAG, MPI_COMM_WORLD, &MPIRequest[0]);
		MPI_Isend(Buffer[2], msglen, MPI_CHAR, iRight, iTAG, MPI_COMM_WORLD, &MPIRequest[2]);
		MPI_Irecv(Buffer[1], msglen, MPI_CHAR, iLeft, iTAG, MPI_COMM_WORLD, &MPIRequest[1]);
		MPI_Irecv(Buffer[3], msglen, MPI_CHAR, iRight, iTAG, MPI_COMM_WORLD, &MPIRequest[3]);
        MPI_Waitall (4, MPIRequest, MPIStatus);
	} 

	MPI_Barrier(comm);
	dEndTime = Wtime ( );
	dUsedTime = dEndTime - dBeginTime;

	Rate = (2.0 * (double) TIMES * msglen)/(dUsedTime);

	for(i = 0; i < 4; i ++)
		free(Buffer[i]);

    return Rate;

} /* End of Ring2 ( ) */
