/* =============================================================
Test 3:  bi-directional transfer via non-blocking calls
			  Scheme
			Node0	Node1
			Isend	Isend
			Irecv	Irecv
			Wait	Wait
================================================================ */


#include"transfer.h"

const char test_description[] = "Bi-directional MPI transfer: Non-blocking Isend/Irecv(3)";

static MPI_Status Statuses[2];
static MPI_Request Requests[2]; 
extern int headproc;

void transfer_test_operation(void *sendbuf,void *recvbuf,int msglen,int rank,int TIMES,int proc)
{
	int the_other;
	int i;	

	if(proc == headproc)
		return;		

	if(rank == headproc || rank == proc)
	{
		the_other = (rank == headproc) ? proc : headproc;

    	    for(i = 0; i < TIMES; i ++) 
			{
				MPI_Isend(sendbuf,msglen,MPI_CHAR,the_other,TAG1,MPI_COMM_WORLD,&Requests[0]);
				MPI_Irecv(recvbuf,msglen,MPI_CHAR,the_other,TAG1,MPI_COMM_WORLD,&Requests[1]);
				MPI_Waitall(2,Requests,Statuses);
			}
	}
}
