#ifndef _MPI_TRANSFER_TEST_
#define _MPI_TRANSFER_TEST_

#include <mpi.h>
#include <stdio.h>
#include <stdlib.h>

/*
an abstract MPI operation which is expected
to transfer messages of size msglen given (TIMES) number of times
between master process and given process.
*/

void transfer_test_operation(void *sendbuf,void *recvbuf,int msglen,int rank,int TIMES, int proc);

#define DEFAULT_TIMES 20
#define MEGABYTE (1024*1024)
#define KILOBYTE 1024
#define MIN_MESSAGE_LENGTH 0
#define MAX_MESSAGE_LENGTH (64*1024)
#define MESSAGE_INCREMENT 1024

#define MASTER 0

#define comm MPI_COMM_WORLD

#define PRINT_RATE 'r'
#define PRINT_TIME 't'

#define TAG1 1001

void fillbuffer(char *buffer,int size,char c);
int checkbuffer(char *buffer,int size,char c);

#endif
